import java.lang.*;
import java.awt.*;
import java.sql.*;
import java.util.*;
import java.io.*;

/**
  * A  extension of the Memopad class
  * to indicate and save text
  */
public class Indication extends Memopad
{
    static int countText;
    static int countWords;
    static String word ="";  
    static String query;
    PreparedStatement pstmt,pstmt1,pstmt2,pstmt3,pstmt4;
   
    public Indication(){
        
			//{{INIT_CONTROLS
		setLayout(null);
		setSize(430,270);
		setTitle("Untitled");
		//}}
		//{{INIT_MENUS
		//}}
}
    /**
    * save and indicate text
    * @param text   text to be indicated
    */
    public void indicate(String text)
    {  
        // Ermittle Anzahl der gespeicherten Texte und Wrter  
        query="SELECT max(t.textNr),max(w.wordNr) FROM tblText t ,tblWord w ";
        c.dbAccess(query,false);
        try { 
            c.rs.next();
            countText=(c.rs).getInt(1); 
            countWords=(c.rs).getInt(2);
            countText++;        
            countWords++;
            c.rs.close();
        }
        catch (SQLException e){
            // there are no entries in DB
            countText=1;
            countWords=1;
            //System.out.println(e.getMessage());
        }
        String n = new TextDialog().textName;    // TextName
        // Save Text in DB
        
        InputStream textStream = new StringBufferInputStream (text);
        int length = text.length();
        try 
        {
        pstmt=c.con.prepareStatement("INSERT INTO tblText VALUES (?,?,?);");
        pstmt.setInt(1,countText);
        pstmt.setAsciiStream(2,textStream,length);
        pstmt.setString(3,n);
        }
        catch (Exception e){
            System.out.println("da");
            System.out.println(e.getMessage());
        }
        c.preparedAccess(pstmt,true);
            try 
            {
                pstmt1=c.con.prepareStatement("SELECT wordNr FROM tblWord WHERE word = ? ");
                pstmt2=c.con.prepareStatement("INSERT INTO tblword VALUES (?,?);");
                pstmt3=c.con.prepareStatement("SELECT wordNr FROM tblTextWord WHERE wordNr = ? AND textNr = ? ");
                pstmt4=c.con.prepareStatement("INSERT INTO tblTextWord VALUES (?,?);");
                // indicate TextName
                word = n;
                pstmt1.setString(1,word);
                insertDB();
            }
            catch (Exception e){
                System.out.println(e.getMessage());
            }
            
            StringTokenizer st = new StringTokenizer(text," \r\n\t\\!?,;.:/*`+#'|{}()[]<>=\"");
            while (st.hasMoreTokens())
            {
                word = st.nextToken();
                int y = word.indexOf('&');
                if (!(y >= 0)) // no html-Code
                {
                    try
                    {
                        pstmt1.setString(1,word);
                        insertDB();
                    }
                    catch (Exception e){
                        System.out.println(e.getMessage());
                    }
                }
            }
            try
            {
                pstmt.close();
                pstmt1.close();
                pstmt2.close();
                pstmt3.close();
                pstmt4.close();
            }
            catch (Exception e) {
                System.out.println(e.getMessage());
            }
    }
    
    /**
      * check and save indicated words
      */
      private void insertDB()
      {
        int wordNum=countWords;
     
        if (word.length()>3)
        {   
            // check if word is already in DB
            c.preparedAccess(pstmt1,false);
        
            try {
                 pstmt2.setInt(1,countWords);
                 pstmt2.setString(2,word);
                 if (c.rs.next()) // word is already in DB
                 {
                    wordNum = c.rs.getInt(1);
                    c.rs.close();
                 }
                 else              // word is not in DB
                 {
                    c.rs.close();
                    c.preparedAccess(pstmt2,true);
                    countWords++;
                 }
            }
            catch (Exception e) {   
                // there are no entries
                if (countWords==1)
                {
                     c.preparedAccess(pstmt2,true);
                     countWords++;
                }
                //System.out.println(e.getMessage());
            }
          
            try {
                pstmt3.setInt(1,wordNum);
                pstmt3.setInt(2,countText);
                c.preparedAccess(pstmt3,false);
                if (c.rs.next()) // wordNr-textNr is already in DB
                {
                    c.rs.close();   // do nothing
                }
                else              // word is not in DB
                {
                    c.rs.close();
                    pstmt4.setInt(1,countText);
                    pstmt4.setInt(2,wordNum);
                    c.preparedAccess(pstmt4,true);
                }
            }
            catch (Exception ex) {
                // Word/Text Nr. is already in DB
                // System.out.println(ex.getMessage());
            }
             
          }   // end if
       }
}

