/**
  * A basic extension of the java.awt.Frame class
  * to get name of the text to be saved, stored in the static variable textName
  */

import java.awt.*;

import symantec.itools.awt.util.ToolBarPanel;
import com.sun.java.swing.*;
import symantec.itools.awt.BorderPanel;
public class TextDialog extends Frame
{
	public TextDialog()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(440,120);
		setFont(new Font("Serif", Font.PLAIN, 16));
		setForeground(new Color(0));
		setBackground(new Color(12632256));
		label1 = new java.awt.Label("  TextName:");
		label1.setBounds(12,14,108,30);
		label1.setFont(new Font("Serif", Font.PLAIN, 16));
		label1.setForeground(new Color(-16760704));
		label1.setBackground(new Color(12632256));
		add(label1);
		textField1 = new java.awt.TextField();
		textField1.setBounds(120,14,300,26);
		textField1.setFont(new Font("Serif", Font.PLAIN, 16));
		add(textField1);
		textField1.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		Quit = new java.awt.Button();
		Quit.setLabel("Quit");
		Quit.setBounds(300,60,85,25);
		Quit.setFont(new Font("Serif", Font.PLAIN, 16));
		Quit.setForeground(new Color(-16760704));
		Quit.setBackground(new Color(12632256));
		add(Quit);
		Ok = new java.awt.Button();
		Ok.setLabel("Ok");
		Ok.setBounds(156,60,85,25);
		Ok.setFont(new Font("Serif", Font.PLAIN, 16));
		Ok.setForeground(new Color(-16760704));
		Ok.setBackground(new Color(12632256));
		add(Ok);
		setTitle("Untitled");
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		Ok.addMouseListener(aSymMouse);
		Quit.addMouseListener(aSymMouse);
		SymAction lSymAction = new SymAction();
		textField1.addActionListener(lSymAction);
		SymComponent aSymComponent = new SymComponent();
		this.addComponentListener(aSymComponent);
		//}}
	
	}

	public TextDialog(String title)
	{
		this();
		setTitle(title);
	}
	
	static String textName;
	
    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);	
	}

	static public void main(String args[])
	{
		(new TextDialog()).setVisible(true);
	}
	
	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.Label label1;
	java.awt.TextField textField1;
	java.awt.Button Quit;
	java.awt.Button Ok;
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == TextDialog.this)
				Frame1_WindowClosing(event);
		}
	}
	
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == textField1)
				textField1_EnterHit(event);
		}
	}
	
    void textField1_EnterHit(java.awt.event.ActionEvent event)
	{
		checkTextName(textField1.getText());
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == Ok)
				button1_MouseClicked(event);
			else if (object == Quit)
				button2_MouseClicked(event);
		}
	}
    // OK
	void button1_MouseClicked(java.awt.event.MouseEvent event)
	{
	    checkTextName(textField1.getText());
	}
	
    // QUIT
	void button2_MouseClicked(java.awt.event.MouseEvent event)
	{
		new Memopad().saveText = false;
		new Memopad().openText = false;
		setVisible(false);
	}

	class SymComponent extends java.awt.event.ComponentAdapter
	{
		public void componentShown(java.awt.event.ComponentEvent event)
		{
			Object object = event.getSource();
			if (object == TextDialog.this)
				TextDialog_ComponentShown(event);
		}
	}

	void TextDialog_ComponentShown(java.awt.event.ComponentEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Select all of the text
		textField1.selectAll();
		//}}
	}
	/**
	  * checks the name of a text, correct name is saved in static var textName
	  * @param name string to check
	  */
	  
	void checkTextName (String name)
	{
	    int y = name.indexOf(' ');
		
		if (name.equals(""))
		{
	        new Attention("Attention!","Textname is required!").setVisible(true);
		    textField1.selectAll();
		}
		else if  (y >= 0) // textName includes blank
        {
            new Attention("Attention!","No blanks within the Textname!").setVisible(true);
            textField1.requestFocus();
	        textField1.selectAll();
        }
	    else
	    {
	        textName=name;
		    setVisible(false);
		}
	}
}
